import jp.ac.takushoku_u.cs.*;

/**
* IRSAnalysis饹Υƥѥ饹
* @version 1.0
* @author  ͵(Kasajima Hiroshi)
*/
/*
* ǽ 2005ǯ0108
*/
class IRSAnalysisTest{

public static void main(String[] args){

	double[][] sampleData = {
		{1,1,1,1,1,1},
		{1,1,1,1,1,1},
		{0,1,1,0,0,0},
		{0,1,1,0,0,0},
		{0,1,1,0,1,1},
		{0,0,1,0,1,1},
		{0,0,1,1,1,1},
		{0,0,0,1,1,1},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}};
	
	String[] rowName = {"1","2","3","4","5",
		"6","7","8","9","10"};
	String[] colName = {"1","2","3","4","5","6"};
	
	//ʬϤԤޥȥꥯ
	ArithmeticMatrix dataMatrix = new ArithmeticMatrix(sampleData, rowName, colName);
	
	//ʬϤԤ
	IRSAnalysis result = new IRSAnalysis(dataMatrix);
	
	//ͤ
	result.setThreshold(0.5);
	
	//ʬоݤΥޥȥꥯν
	
	//ѥޥȥꥯ
	ArithmeticMatrix outMatrix = new ArithmeticMatrix(10,6);
	System.out.println("Υޥȥꥯ");
	//ޥȥꥯ
	outMatrix.matrixCopy(result.getMatrix());
	//ޥȥꥯν
	outputMatrix(outMatrix);
	
	//ޥȥꥯν
	ArithmeticMatrix outCofficient = new ArithmeticMatrix(6,6);
	outCofficient.matrixCopy(result.getCoefficientMatrix());
	System.out.println("ޥȥꥯ");
	outputDoubleMatrix(outCofficient);
	
	//ʬϷ̤ǤIRSޥȥꥯν
	ArithmeticMatrix outIRSMatrix = new ArithmeticMatrix(6,6);
	outIRSMatrix.matrixCopy(result.getIRSMatrix());
	System.out.println("IRSޥȥꥯ");
	outputMatrix(outIRSMatrix);
	
	//ȥޥȥꥯν
	ArithmeticMatrix outSkeletonMatrix = new ArithmeticMatrix(6,6);
	outSkeletonMatrix.matrixCopy(result.getSkeletonMatrix());
	System.out.println("ȥޥȥꥯ");
	outputMatrix(outSkeletonMatrix);
	
	//ޤγƽ֤ν
	//Ϥ0ϤޤֹǽϤޤ
	int[] col = new int[sampleData[0].length];
	System.arraycopy(result.getGraphElementArray(), 0, col, 0, col.length);
	System.out.print("ޤ񤯽: ");
	for(int i = 0; i < col.length; i++){
		System.out.print((col[i]) + ", ");
	}
}
	
/**
* ޥȥꥯintɸϤ˽Ϥޤ
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//̾
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//̾
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* ޥȥꥯdoubleɸϤ˽Ϥޤ
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.000");		//ʲ3ޤǽ
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + " ");		//̾
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//̾
			for(int j = 0; j < outMatrix.getColLength(); j++){		//ǽ
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+" ");
				}
			}
		}
		System.out.println();
	}
	
}
